C*****************************************
       program disorientation calc
C*****************************************
       implicit none
	   include 'common.fi'
       dimension e1(3), e2(3)
       dimension gg1(3,3), gg2(3,3), dg(3,3)
       dimension so1(3,3), so2(3,3), sa(2), so2t(3,3)

       write(6,*) '=============================================='
	   write(6,*) ' PROGRAM USED TO TO DETERMINE THE DISORIENTATION '
	   write(6,*) ' DISTRIBUTION FROM LINE SEGMENT DATA IN '
	   write(6,*) ' ORTHORHOMBIC, TRIGONAL, TETRAGONAL, HEXAGONGAL, '
	   write(6,*) ' AND CUBIC SYSTEMS '
	   write(6,*)
	   write(6,*) ' rohrer@cmu.edu'	   
	   write(6,*) ' version 07/27/2013'
       write(6,*) '=============================================='
	   
	   version = 'version 07/27/2013'	   
	   
       pi = 4.0*atan(1.0)
	   eps = 1.e-6
	   HCD = 90.0
	   len = 0.0
	   lentot = 0.0
	   len1 = 0.0
	   len2 = 0.0
	   len3 = 0.0
	   ct=0

c  The section reads information from the input file, including the data file name,
c  the symmetry type.

       open(21, file='input.txt', status='old')
	   !read(21,*)
	   read(21,*) keyword
	   read(21,*) tempword, tempword, tempword
       read(21,*) msym, rotation, radian
	   read(21,*) tempword   
	   read(21,*) segs	   
	   read(21,*) tempword   
	   read(21,*) stepsize
	   read(21,*) tempword   
	   read(21,*) l_cut
	   read(21,*) tempword
	   read(21,*) bin

       if (msym.eq.1) limit=99  !max eq 98.42,  D4, 422, 4/m mm
	   if (msym.eq.2) limit=94  !max eq 93.84,  D6, 622, 6/m mm	   
	   if (msym.eq.3) limit=63  !max eq 62.7994, O, 432, m-3m
	   if (msym.eq.4) limit=105 !max eq 104.5,  D3,  32, -3m
	   if (msym.eq.5) limit=120 !max eq 120.0,  D2, 222, mmm
	   	   
 10     format(A,A)
	    write(6,10)'I am going to look for data in the file labeled: ', keyword
 11     format(A,I2,2X,A,I2,2X,A,I2)
 12     format(A,I2,2X,A,f4.1,2X,A,f4.1) 
 13     format(A,I2) 
	    write(6,11)'msym =',msym,'rotation =',rotation,'radian =',radian
	    write(6,12)'segment analysis =',segs,'step size =',stepsize,'length cutoff =',l_cut	 
		write(6,13)'degrees per bin =',bin
	    close(21)


c  The statement calls the subroutine that contains the symmetry operators.  The variable
c  msym, read from the input file, specifies the symmetry (1 = tetragonal, 2 = hexagonal, 
c  3 = subic, 4 = trigonal), O is a matrix containing the operators, and nsymm is the 
c  number of symmetry operators.  The routine returns O and nsymm.

       call get_symop (msym, O, nsymm)
		
 		do i=1,180
		 d(i,1)=0.0
		 d(i,2)=0.0
		enddo
		
c  This part is to determines the total number of line segments (lines in the data file),
c  assigned to the variable, nnline
		
		ct1=0
		ct2=0
		ct3=0
		
		nnline = 0
		open(41, file=keyword, status='old')
 60     continue
		read(41,*,end=61)
		nnline=nnline+1
		goto 60
 61     continue
        close(41)

 72		format(A,I7,A)
		write(6,72) 'There are',nnline,' lines in the data file.'
		
c Check each line for the string '#'. If found, we know this line is part  
c of the header.  If not, we have reached the data section.		
	   open(41, file=keyword, status='old')
       header = 0
       hash = 0
	   do i=1,nnline
	    read(41, "(a)") inline
	    hash = index(inline, '#')
	    if (hash.ne.0) then
	     header=header+1
		 hash=0
	    else
		 goto 80     
	    endif			
	   enddo

 80    close(41)				
	   write(6,*)header,' lines in the header'	
	   
ccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	   
c       here, we figure out the average length of the segments
c       this is one figure of merit for the reliability of the 
c       results

		 open(41, file=keyword, status='old')
		 
c       read the header
         do i=1,header
	      read(41, "(a)") inline
	     enddo			 
		 
		 l_tot=0.0	
		 t_out=0
		
 110     continue
		 read(41,*,end=120) e1(1), e1(2), e1(3), e2(1), e2(2), e2(3), 
     &	 temp, temp, x1, y1, x2, y2

         nl(1)=x2-x1
		 nl(2)=y2-y1
	     length=sqrt((nl(1)*nl(1))+(nl(2)*nl(2)))
		 steps=nint(length/stepsize)
		 l_steps=length/stepsize
		 l_tot=l_tot+l_steps
		 t_out=t_out+1
		 goto 110
 120     continue		 
		 close(41)
		 l_ave=l_tot/float(t_out)
		
         write(6,206)'on average, there are ',l_ave,' steps per segment'

c  Depending on how this parameter is set in the input file, the 
c  segment analysis can be skipped

        if (segs.ne.0) then

c  This section analyzes the distribution of line lengths	

		do i = 1,200
		 ls(i) = 0
		end do
		l_tot=0.0
		t_out=0
		
		open(41, file=keyword, status='old')

c  read the header
        do i=1,header
	     read(41, "(a)") inline
	    enddo
		
 200    continue
		 read(41,*,end=201) e1(1), e1(2), e1(3), e2(1), e2(2), e2(3), 
     &	 temp, temp, x1, y1, x2, y2

         nl(1)=x2-x1
		 nl(2)=y2-y1
	     length=sqrt((nl(1)*nl(1))+(nl(2)*nl(2)))
		 steps=nint(length/stepsize)
		 l_steps=length/stepsize
		 
		 
		 if (l_steps.lt.l_cut) then
		  t_out=t_out+1
		 endif
		 
		 if (steps.eq.0) then
		  steps=1
		 endif

		 if (steps.gt.200) then
		  steps=200
		 endif
		 
		 ls(steps) = ls(steps)+1
		 l_tot=l_tot+l_steps
		
		 goto 200
 201    continue		 
		close(41)

        l_ave=l_tot/float(nnline)
		
 204    format(A,I9)		
 205	format(f5.1,A)	
 206    format(A,F5.1,A)
 207    format(A,F4.1,A,I5,A)
 
        smalls=100*(float(ls(1)+ls(2)+ls(3)+ls(4)+ls(5)+
     &  ls(6)+ls(7))/float(nnline))
        write(6,205) smalls, '% of the segments are less than 7.5 steps'
        smalls=100*(float(ls(1)+ls(2)+ls(3)+ls(4)+ls(5)+
     &  ls(6))/float(nnline))
        write(6,205) smalls, '% of the segments are less than 6.5 steps'
		smalls=100*(float(ls(1)+ls(2)+ls(3)+ls(4)+ls(5))/float(nnline))
        write(6,205) smalls, '% of the segments are less than 5.5 steps'
		smalls=100*(float(ls(1)+ls(2)+ls(3)+ls(4))/float(nnline))
        write(6,205) smalls, '% of the segments are less than 4.5 steps'
		smalls=100*(float(ls(1)+ls(2)+ls(3))/float(nnline))
        write(6,205) smalls, '% of the segments are less than 3.5 steps'
        smalls=100*(float(ls(1)+ls(2))/float(nnline))
        write(6,205) smalls, '% of the segments are less than 2.5 steps'
        smalls=100*(float(ls(1))/float(nnline))
        write(6,205) smalls, '% of the segments are less than 1.5 steps'

        write(6,206)'on average, there are ',l_ave,' steps per segment'
        write(6,207)'with a cut-off of',l_cut,', ',t_out,' segments 
     &  will be ignored because they are too small.'
		smalls=100*(float(t_out)/float(nnline))
        write(6,205) smalls, '% of the segments will be ignored.'
		
		
		open(25, file='segment_stats_'//keyword, status='unknown')
		write(25,72) 'There are',nnline,' lines in the data file.'
		write(25,206)'on average, there are ',l_ave,' steps per segment'
        smalls=100*(float(ls(1)+ls(2)+ls(3)+ls(4)+ls(5)+
     &  ls(6)+ls(7))/float(nnline))
        write(25,205)smalls, '% of the segments are less than 7.5 steps'
        smalls=100*(float(ls(1)+ls(2)+ls(3)+ls(4)+ls(5)+
     &  ls(6))/float(nnline))
        write(25,205)smalls, '% of the segments are less than 6.5 steps'
		smalls=100*(float(ls(1)+ls(2)+ls(3)+ls(4)+ls(5))/float(nnline))
        write(25,205)smalls, '% of the segments are less than 5.5 steps'
		smalls=100*(float(ls(1)+ls(2)+ls(3)+ls(4))/float(nnline))
        write(25,205)smalls, '% of the segments are less than 4.5 steps'
		smalls=100*(float(ls(1)+ls(2)+ls(3))/float(nnline))
        write(25,205)smalls, '% of the segments are less than 3.5 steps'
	    smalls=100*(float(ls(1)+ls(2))/float(nnline))
        write(25,205)smalls, '% of the segments are less than 2.5 steps'
        smalls=100*(float(ls(1))/float(nnline))
        write(25,205)smalls, '% of the segments are less than 1.5 steps'
        write(25,207)'with a cut-off of',l_cut,', ',t_out,' segments 
     &  will be ignored because they are too small.'
        smalls=100*(float(t_out)/float(nnline))
        write(25,205)smalls, '% of the segments will be ignored.'	
		
c       here, we figure out the average length of the remaining segments

		 open(41, file=keyword, status='old')
		 
c  read the header
        do i=1,header
	     read(41, "(a)") inline
	    enddo			 
		 
		 l_tot=0.0	
		 t_out=0
		
 300    continue
		 read(41,*,end=301) e1(1), e1(2), e1(3), e2(1), e2(2), e2(3), 
     &	 temp, temp, x1, y1, x2, y2

         nl(1)=x2-x1
		 nl(2)=y2-y1
	     length=sqrt((nl(1)*nl(1))+(nl(2)*nl(2)))
		 steps=nint(length/stepsize)
		 l_steps=length/stepsize
		 
		 if (l_steps.ge.l_cut) then
			l_tot=l_tot+l_steps
			t_out=t_out+1
		 endif	
		
		 goto 300
 301    continue		 
		close(41)

		 l_ave=l_tot/float(t_out)
		
        write(25,206)'on average, there are ',l_ave,' steps per segment
     &  for the segments included'
        write(6,206)'on average, there are ',l_ave,' steps per segment 
     &  for the segments included'
		
		
		write(25,*)' '
        write(25,*)'the following is a histogram of the number of segments 
     &  with a certain step length'
		write(25,*) 'length, steps    number'
		do i = 1,200
		 write(25,*)i, ls(i)
		end do

        close(25)
		

        endif  ! this ends the segment analysis branch

ccccccccccccccccccccccccccccccccccccccccccccccccc
	   
	
        open(30, file='report_'//keyword, status='unknown')
		
		open(41, file=keyword, status='old')
		nline = 0
c       read the header
         do i=1,header
	      read(41, "(a)") inline
		  write(30, "(a)")inline
	     enddo	

		 
 83      format(A,A)    
 117     format(7f9.3,f8.2,4f11.2)	
		
 		do kk=header+1,nnline
c		write(6,*)kk
c  This section reads a single line from the data file

		read(41,*) e1(1), e1(2), e1(3), e2(1), e2(2), e2(3), 
     &	temp, temp, x1, y1, x2, y2
	 
C This skips over the segments that are below the cut off	 
	if (segs.ne.0) then
		nl(1)=x2-x1
		nl(2)=y2-y1
		length=sqrt((nl(1)*nl(1))+(nl(2)*nl(2)))
		steps=nint(length/stepsize)
		l_steps=length/stepsize
		
		if (l_steps.lt.l_cut) then 
		  goto 4000
		endif
	 endif
	 
	
c  This part converts angular data to radians, if specified in the input file
c  by the variable, radian
				
	    if (radian.eq.0) then
	     e1(1)=e1(1)*(pi/180.0)
	     e1(2)=e1(2)*(pi/180.0)
	     e1(3)=e1(3)*(pi/180.0)

	     e2(1)=e2(1)*(pi/180.0)
	     e2(2)=e2(2)*(pi/180.0)
	     e2(3)=e2(3)*(pi/180.0)
	    endif

c  If the data are in the HKL reference frame, and the system is hexagonal,
c  then the data are rotated by -30 so that [2-1-10] is parallel to +x in 
c  the output (this direction is to the right in the plane of the paper)
		
	    if (rotation.eq.0.and.msym.eq.2) then
	     if (e1(3).gt.(30*pi/180)) then
 	      e1(3) = e1(3)-(30*pi/180)
		 else
		  e1(3) = e1(3)+(330*pi/180)
		 endif
		 if (e2(3).gt.(30*pi/180)) then
 	      e2(3) = e2(3)-(30*pi/180)
		 else
		  e2(3) = e2(3)+(330*pi/180)
		 endif
		endif
		
c  This part converts the Euler angles from the input file to a g matrix

        call EToG(e1,g1)
		call EToG(e2,g2)

c This section determines the length of the grain boundary segment

		nl(1)=x2-x1
		nl(2)=y2-y1
        nl(3)=0.0
		line=nl
	    length=sqrt(nl(1)*nl(1)+nl(2)*nl(2))
		lentot=lentot+length

c In this section, we need to find the minimum misorientation for each observation

		disor2 = 3.1415 ! max disorientation
		do i_s=1,nsymm	
		 call symop(O,i_s,so1)
		 call MToM (so1,g1,gg1)
		  do j_s=1,nsymm
		   call symop(O,j_s,so2)
		   call MToM(so2,g2,gg2)
		   call trans(gg2,gt)
		   call MToM(gg1,gt,dg)
		   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1)/2)
		   !write(6,*) misor	
           if (misor.lt.disor2) then
            disor2=misor
           endif
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
		   if (misor.lt.disor2) then
			disor2=misor
		   endif
		  enddo
		 enddo
		 ct=ct+1
		 
c        now we have to bin the observation in the matix d.  The first
c        position accumulates the length and the second the number.

		 disor2=disor2*(180.0/pi)
		 ind = floor(disor2)
		 if (ind.eq.0) ind=1
		 if (ind.gt.limit) then
		  ind=limit
		  write(6,*)'misorientation out of bounds'
		 endif 
		 d(ind,1)=d(ind,1)+length
		 d(ind,2)=d(ind,2)+1.0

 4000    continue		   
 5000	 enddo
 
		 write(6,*)'segments analyzed = ', ct
 
c  BINNING OPTION !!!!
c bins such that the 0 bin angles range from 0-1, 1 from 1-2 etc. 

		  if (bin.gt.1) then
		     do i=0,180,bin
			 do ko=i,i+bin
				if(ko.eq.i) then
				d(i,1)=(d(ko,1))
				d(i,2)=(d(ko,2))
				else
				d(i,1)=(d(i,1)+d(ko,1))
				d(i,2)=(d(i,2)+d(ko,2))
				endif
			enddo
			d(i,1)=d(i,1)/bin
			d(i,2)=d(i,2)/bin
			enddo	
		  endif

c         normalize the result

			do i=0,180,bin
			 d_norm(i,1)=d(i,1)*(180.0/lentot)
             d_norm(i,2)=d(i,2)*(180.0/ct)	
		    enddo
		
 5200     format(I3,7x,F11.3,5x,F11.5)
 5201     format(A)
          write(6,5201)' '
          write(30,5201)' '	
          write(6,5201)'Disorientation distribution: rotation angle, length fraction, and number fraction'
          write(30,5201)'Disorientation distribution: rotation angle, length fraction, and number fraction'	
          write(6,5201)' '
          write(30,5201)' '	
		            
          write(6,5201)'degrees    length     number'
          write(30,5201)'degrees    length     number'		  
		  

		  
          do i=0,limit,bin
          write(30,*)i, d_norm(i,1),d_norm(i,2)
          write(6,5200)i, d_norm(i,1),d_norm(i,2)		  
		  enddo
 
          close(30)
		  
       end
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   